Index: evolution.spec
===================================================================
RCS file: /cvs/dist/devel/evolution/evolution.spec,v
retrieving revision 1.134
diff -u -r1.134 evolution.spec
--- evolution.spec	14 Mar 2006 06:57:34 -0000	1.134
+++ evolution.spec	4 Apr 2006 19:46:54 -0000
@@ -43,7 +43,7 @@
 License: GPL
 BuildRoot: %{_tmppath}/%{name}-%{version}-root
 URL: http://www.ximian.com/
-Source0: ftp://ftp.gnome.org/pub/gnome/stable/sources/evolution/2.1/%{name}-%{version}.tar.bz2
+Source0:	http://ftp.gnome.org/pub/gnome/sources/evolution/2.6/%{name}-%{version}.tar.bz2
 
 # patches pulled from upstream CVS
 
@@ -121,10 +121,6 @@
 Requires: libgnomeprint22 >= %{libgnomeprint22_version}
 Requires: gnome-vfs2 >= %{gnomevfs2_version}
 
-%if %{libnotify_support}
-Requires: libnotify
-%endif
-
 Obsoletes: libgal2 <= %{last_libgal2_version}
 
 BuildRequires: gtkhtml3-devel >= %{gtkhtml_version}
@@ -206,6 +202,15 @@
 %description devel
 Development files needed for building things which link against evolution.
 
+%package pilot
+Summary:	Evolution conduits for gnome-pilot
+Group:		Applications/Productivity
+Requires:	%{name} = %{version}-%{release}
+
+%description pilot
+This package contains conduits needed by gnome-pilot to synchronize
+your Palm with Evolution.
+
 %prep
 %setup -q
 # these are in CVS already on the 1-4-branch
@@ -305,24 +310,19 @@
 fi
 %endif
 
-# Rerun autotools since we patched configure.in (patch for new-mail-notify plugin) and some Makefile.am files (conduit paths):
-aclocal
-autoheader
-automake
-libtoolize
-intltoolize --force
-autoconf
-
-# Configuration:
+autoreconf -f
 %configure \
-  --enable-gtk-doc=yes \
-  --enable-ipv6 \
-  --enable-file-locking=fcntl --enable-dot-locking=no \
-  --with-sub-version=" (%{version}-%{release})" \
-  --with-kde-applnk-path=no \
-  --enable-file-chooser=yes \
-  %ldap_flags %pilot_flags %krb5_flags %nntp_flags %ssl_flags %exchange_flags \
-  --enable-plugins=all
+	--disable-dot-locking \
+	--disable-schemas-install \
+	--disable-static \
+	--enable-file-chooser \
+	--enable-file-locking=fcntl \
+	--enable-gtk-doc \
+	--enable-ipv6 \
+	--enable-plugins=all
+	--without-kde-applnk-path \
+	--with-sub-version=" (%{version}-%{release})" \
+	%ldap_flags %pilot_flags %krb5_flags %nntp_flags %ssl_flags %exchange_flags
 export tagname=CC
 
 # Do the make, with various flags:
@@ -332,24 +332,10 @@
 make %{?_smp_mflags} LIBTOOL=%{_bindir}/libtool CFLAGS="$CFLAGS -UGNOME_DISABLE_DEPRECATED"
 %endif
 
-#cat /dev/null > default_user/local/Inbox/mbox
-
 %install
 rm -rf $RPM_BUILD_ROOT
-export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
 export tagname=CC
 make LIBTOOL=%{_bindir}/libtool DESTDIR=$RPM_BUILD_ROOT install
-unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
-
-# remove libtool archives for importers and the like
-find $RPM_BUILD_ROOT/%{_libdir}/evolution -name '*.la' -exec rm {} \;
-
-# remove statically built libraries:
-find $RPM_BUILD_ROOT/%{_libdir}/evolution -name '*.a' -exec rm {} \;
-
-# pilot conduits static and libtool bits should go away too
-rm -f $RPM_BUILD_ROOT/%{_libdir}/gnome-pilot/conduits/*.a
-rm -f $RPM_BUILD_ROOT/%{_libdir}/gnome-pilot/conduits/*.la
 
 # remove additional things we don't want
 %if ! %{inline_audio_support}
@@ -357,23 +343,22 @@
            $RPM_BUILD_ROOT%{evo_plugin_dir}/liborg-gnome-audio-inline.so
 %endif
 
-# scrollkeeper gets handled in %post
-rm -rf $RPM_BUILD_ROOT/var/scrollkeeper
-
 # evolution is the preferred email app
-ln -sf ../desktop-menu-patches/redhat-evolution-mail.desktop $RPM_BUILD_ROOT/%{_datadir}/applications/
-ln -sf ../desktop-menu-patches/redhat-evolution-calendar.desktop $RPM_BUILD_ROOT/%{_datadir}/applications/
-ln -sf ../desktop-menu-patches/redhat-evolution-contacts.desktop $RPM_BUILD_ROOT/%{_datadir}/applications/
-ln -sf ../desktop-menu-patches/redhat-evolution-tasks.desktop $RPM_BUILD_ROOT/%{_datadir}/applications/
+ln -sf ../desktop-menu-patches/redhat-evolution-mail.desktop $RPM_BUILD_ROOT%{_datadir}/applications/
+ln -sf ../desktop-menu-patches/redhat-evolution-calendar.desktop $RPM_BUILD_ROOT%{_datadir}/applications/
+ln -sf ../desktop-menu-patches/redhat-evolution-contacts.desktop $RPM_BUILD_ROOT%{_datadir}/applications/
+ln -sf ../desktop-menu-patches/redhat-evolution-tasks.desktop $RPM_BUILD_ROOT%{_datadir}/applications/
 
 # remove upstream desktop file; use the symlinks from above (#103826)
-rm -f $RPM_BUILD_ROOT/%{_datadir}/applications/evolution.desktop
+rm -f $RPM_BUILD_ROOT%{_datadir}/applications/evolution.desktop
 
 rm -f $RPM_BUILD_ROOT%{_datadir}/mime-info/evolution.keys
 rm -f $RPM_BUILD_ROOT%{_datadir}/mime-info/evolution.mime
 
+rm -f $RPM_BUILD_ROOT%{_libdir}/*{,/*}/*.la
+
 # evolution link
-ln -sf ./evolution-%{evo_major} $RPM_BUILD_ROOT/%{_bindir}/evolution
+ln -sf ./evolution-%{evo_major} $RPM_BUILD_ROOT%{_bindir}/evolution
 
 for serverfile in $RPM_BUILD_ROOT%{_libdir}/bonobo/servers/*.server; do
     sed -i -e 's|location *= *"/usr/lib\(64\)*/|location="/usr/$LIB/|' $serverfile
@@ -398,7 +383,7 @@
 
 %files -f %{name}-%{evo_major}.lang
 %defattr(-, root, root)
-%doc AUTHORS COPYING ChangeLog INSTALL NEWS README
+%doc AUTHORS COPYING ChangeLog NEWS README
 
 # GConf schemas:
 %{_sysconfdir}/gconf/schemas/apps-evolution-mail-prompts-checkdefault-%{evo_major}.schemas 
@@ -477,23 +462,6 @@
 %{_libexecdir}/evolution/%{evo_major}/evolution-alarm-notify
 %{_libexecdir}/evolution/%{evo_major}/killev
 
-# Various conduits for gnome-pilot:
-%if %{pilot_support}
-%dir %{_libdir}/evolution/%{evo_major}/conduits
-
-%{_libdir}/evolution/%{evo_major}/conduits/libeaddress_conduit.so
-%{_libdir}/gnome-pilot/conduits/e-address-%{evo_major}.conduit
-
-%{_libdir}/evolution/%{evo_major}/conduits/libecalendar_conduit.so
-%{_libdir}/gnome-pilot/conduits/e-calendar-%{evo_major}.conduit
-
-%{_libdir}/evolution/%{evo_major}/conduits/libememo_conduit.so
-%{_libdir}/gnome-pilot/conduits/e-memo-%{evo_major}.conduit
-
-%{_libdir}/evolution/%{evo_major}/conduits/libetodo_conduit.so
-%{_libdir}/gnome-pilot/conduits/e-todo-%{evo_major}.conduit
-%endif
-
 # The plugin directory:
 %dir %{evo_plugin_dir}
 
@@ -634,6 +602,13 @@
 %{_libdir}/evolution/%{evo_major}/libfilter.so
 %{_libdir}/evolution/%{evo_major}/libmenus.so
 
+%if %{pilot_support}
+%files pilot
+%defattr(644,root,root,755)
+%attr(755,root,root) %{_libdir}/evolution/conduits/*.so
+%{_datadir}/gnome-pilot/conduits/*
+%endif
+
 %changelog
 * Mon Mar 13 2006 Ray Strode <rstrode@redhat.com> - 2.6.0-1
 - 2.6.0