diff --git a/en-US/Tour_of_the_GNOME_desktop.xml b/en-US/Tour_of_the_GNOME_desktop.xml
index c2e9e3e..22519a1 100644
--- a/en-US/Tour_of_the_GNOME_desktop.xml
+++ b/en-US/Tour_of_the_GNOME_desktop.xml
@@ -11,88 +11,93 @@
 		If you installed Fedora &PRODVER; from the Fedora &PRODVER; Live image, whether for Intel or compatible (i686), PowerPC (ppc), or 64-bit (x86_64), GNOME is the installed desktop. You can find details of two alternative desktops in <xref linkend="chap-User_Guide-Tour_of_the_KDE_desktop" /> and <xref linkend="chap-User_Guide-Tour_of_the_Xfce_desktop" />.
 	</para>
 	<section id="sect-User_Guide-Tour_of_the_GNOME_desktop-_The_GNOME_desktop_">
-		<!--                                                                                                                                                    The GNOME desktop                                                                                                                                                    --><title> The GNOME desktop </title>
+		<!--                                                                                                                                                    The GNOME desktop                                                                                                                                                    --><title> The GNOME Desktop </title>
 		<figure float="0" id="figu-User_Guide-_The_GNOME_desktop_-The_GNOME_desktop">
-			<title>The GNOME desktop</title>
+			<title>The GNOME Desktop</title>
 			<mediaobject>
 				<imageobject>
 					<imagedata fileref="images/gnome_desktop/gnome_desktop.png" format="PNG" scalefit="1" />
 				</imageobject>
 				<textobject>
 					<para>
-						The GNOME desktop
+						The GNOME Desktop
 					</para>
 				</textobject>
 			</mediaobject>
 		</figure>
 		<para>
-			The GNOME desktop has three distinct areas. From top to bottom, they are: 
+			The GNOME Desktop has three distinct areas. From top to bottom, they are: 
 			<itemizedlist>
 				<listitem>
 					<para>
-						the <firstterm>top menu panel</firstterm> (the gray bar at the top).
+						the <firstterm>Top Menu Panel</firstterm> (the gray bar at the top).
 					</para>
 				</listitem>
 				<listitem>
 					<para>
-						the <firstterm>desktop area</firstterm> (the workspace area in the center that fills most of the screen).
+						the <firstterm>Desktop Area</firstterm> (the workspace area in the center that fills most of the screen).
 					</para>
 				</listitem>
 				<listitem>
 					<para>
-						the <firstterm>window list panel</firstterm> (the gray bar at the bottom).
+						the <firstterm>Window List Panel</firstterm> (the gray bar at the bottom).
 					</para>
 				</listitem>
 			</itemizedlist>
 		</para>
 		<section id="sect-User_Guide-_The_GNOME_desktop_-_The_top_menu_panel_">
-			<!--                                                                                                                                                    The top menu panel                                                                                                                                                    --><title> The top menu panel </title>
+			<!--                                                                                                                                                    The top menu panel                                                                                                                                                    --><title> The Top Menu Panel </title>
 			<para>
 				This panel stretches across the top of the screen. The left side contains: 
 				<itemizedlist>
 					<listitem>
 						<para>
-							the <firstterm>applications menu</firstterm>.
+							the <firstterm>Applications Menu</firstterm>.
 						</para>
 					</listitem>
 					<listitem>
 						<para>
-							the <firstterm>places menu</firstterm>.
+							the <firstterm>Places Menu</firstterm>.
 						</para>
 					</listitem>
 					<listitem>
 						<para>
-							the <firstterm>system menu</firstterm>.
+							the <firstterm>System Menu</firstterm>.
 						</para>
 					</listitem>
 					<listitem>
 						<para>
-							program icons for the default email program, web browser, and reminder notes.
+							Program Icons for the default email program, web browser, and reminder notes.
 						</para>
 					</listitem>
 				</itemizedlist>
 			</para>
 			<para>
-				The right side of the panel is home to: 
+				The right side of the Panel is home to: 
 				<itemizedlist>
 					<listitem>
 						<para>
-							the <firstterm>notification area</firstterm>.
+							the <firstterm>Notification area</firstterm>.
 						</para>
 					</listitem>
 					<listitem>
 						<para>
-							a volume control.
+							a Volume Control.
 						</para>
 					</listitem>
 					<listitem>
 						<para>
-							the <firstterm>user switch area</firstterm>.
+							the <firstterm>Applet Network Manager</firstterm>.
 						</para>
 					</listitem>
 					<listitem>
 						<para>
-							a clock and calendar.
+							the <firstterm>User Switch area</firstterm>.
+						</para>
+					</listitem>
+					<listitem>
+						<para>
+							a Clock and Calendar.
 						</para>
 					</listitem>
 				</itemizedlist>
@@ -135,6 +140,11 @@
 						</listitem>
 						<listitem>
 							<para>
+								<guisubmenu>Other</guisubmenu>
+							</para>
+						</listitem>
+						<listitem>
+							<para>
 								<guisubmenu>Programming</guisubmenu>
 							</para>
 						</listitem>
@@ -200,6 +210,14 @@
 							</para>
 						</listitem>
 						<listitem>
+										<para>
+											<menuchoice><guilabel>Bookmark</guilabel></menuchoice>, a list of folders that you have bookmarked in <application>Nautilus</application>. 
+										</para>
+									</listitem>
+								</itemizedlist>
+							</para>
+						</listitem>
+						<listitem>
 							<para>
 								The second subsection allows quick access to: 
 								<itemizedlist>
@@ -280,21 +298,27 @@
 														<menuchoice><guilabel>Assistive Technologies</guilabel></menuchoice> lets you choose software to magnify portions of the screen or to read the contents of screens to you.
 													</para>
 												</listitem>
-												<listitem>
+										<!--		<listitem>
 													<para>
-														<menuchoice><guilabel>Authorizations</guilabel></menuchoice> lets you selectively permit the software on your computer to carry out certain tasks automatically and without your intervention.
+									 		<menuchoice><guilabel>Authorizations</guilabel></menuchoice> lets you selectively permit the software on your computer to carry out certain tasks automatically and without your intervention.
 													</para>
-												</listitem>
+												</listitem>    -->
 												<listitem>
 													<para>
 														<menuchoice><guilabel>Bluetooth</guilabel></menuchoice> configures Bluetooth devices to work with your computer
 													</para>
 												</listitem>
-												<listitem>
+												<!-- <listitem>
 													<para>
 														<menuchoice><guilabel>Default Printer</guilabel></menuchoice> specifies the printer to use by default.
-													</para>
-												</listitem>
+													</para> 
+												</listitem> -->
+												<listitem>
+													<para>
+														<menuchoice><guilabel>Color Profiles</guilabel></menuchoice> to manage, install and generate color profiles.
+													</para> 
+												</listitem> 
+
 												<listitem>
 													<para>
 														<menuchoice><guilabel>Desktop Effects</guilabel></menuchoice> enables or disables special visual effects for the desktop.
@@ -305,6 +329,12 @@
 														<menuchoice><guilabel>Display</guilabel></menuchoice> sets the resolution and other details of your display.
 													</para>
 												</listitem>
+								 				<listitem>
+													<para>
+														<menuchoice><guilabel>Emphaty</guilabel></menuchoice> an instant messaging client and VoIP application
+
+													</para>
+												</listitem>
 												<listitem>
 													<para>
 														<menuchoice><guilabel>File Management</guilabel></menuchoice> controls how files and folders are presented to you.
@@ -325,11 +355,11 @@
 														<menuchoice><guilabel>Keyboard Shortcuts</guilabel></menuchoice> sets key combinations to perform certain tasks within certain programs, or within the desktop environment more generally.
 													</para>
 												</listitem>
-												<listitem>
+												<!-- <listitem>
 													<para>
 														<menuchoice><guilabel>Main Menu</guilabel></menuchoice> lets you add, remove, or re-order the items on the <guilabel>Applications</guilabel> and <guilabel>System</guilabel> menus, or create new menus of your own.
 													</para>
-												</listitem>
+												</listitem> -->
 												<listitem>
 													<para>
 														<menuchoice><guilabel>Mouse</guilabel></menuchoice> configures the buttons and other controls on your mouse.
@@ -345,11 +375,11 @@
 														<menuchoice><guilabel>Network Proxy</guilabel></menuchoice> allows you to specify a <firstterm>proxy server</firstterm> for your computer.
 													</para>
 												</listitem>
-												<listitem>
+											<!--	<listitem>
 													<para>
 														<menuchoice><guilabel>PalmOS Devices</guilabel></menuchoice> links your computer to personal digital assistants (PDAs) that use the PalmOS operating system.
 													</para>
-												</listitem>
+												</listitem> -->
 												<listitem>
 													<para>
 														<menuchoice><guilabel>Personal File Sharing</guilabel></menuchoice> lets you share your documents and other files with other users of this computer or with users of other computers over a network.
@@ -377,6 +407,11 @@
 												</listitem>
 												<listitem>
 													<para>
+														<menuchoice><guilabel>Seahorse-Preferences</guilabel></menuchoice> allows you to set the cipher-key's properties.
+													</para>
+												</listitem>
+												<listitem>
+													<para>
 														<menuchoice><guilabel>Software Updates</guilabel></menuchoice> specifies how you would like your computer to handle software updates when they become available.
 													</para>
 												</listitem>
@@ -390,11 +425,11 @@
 														<menuchoice><guilabel>Startup Applications</guilabel></menuchoice> chooses applications to start automatically when you log in.
 													</para>
 												</listitem>
-												<listitem>
+											<!--	<listitem>
 													<para>
 														<menuchoice><guilabel>Windows</guilabel></menuchoice> controls the appearance of the windows that applications appear in.
 													</para>
-												</listitem>
+												</listitem> -->
 											</itemizedlist>
 										</para>
 									</listitem>
@@ -453,11 +488,11 @@
 														<menuchoice><guilabel>Printing</guilabel></menuchoice> allows you to configure your printers.
 													</para>
 												</listitem>
-												<listitem>
+									<!--			<listitem>
 													<para>
 														<menuchoice><guilabel>Root Password</guilabel></menuchoice> lets you to change the root password for the system.
 													</para>
-												</listitem>
+												</listitem> -->
 												<listitem>
 													<para>
 														<menuchoice><guilabel>SELinux Management</guilabel></menuchoice> allows you to change security settings that protect your computer.
@@ -468,11 +503,11 @@
 														<menuchoice><guilabel>Services</guilabel></menuchoice> lets you decide which services will run when the system starts.
 													</para>
 												</listitem>
-												<listitem>
+											<!--	<listitem>
 													<para>
 														<menuchoice><guilabel>Software Sources</guilabel></menuchoice> permits you to enable or disable software repositories.
 													</para>
-												</listitem>
+												</listitem> -->
 												<listitem>
 													<para>
 														<menuchoice><guilabel>Update System</guilabel></menuchoice> looks for software updates at your selected software sources.
@@ -489,6 +524,10 @@
 								</itemizedlist>
 							</para>
 						</listitem>
+<!--
+Documents
+-->
+
 						<listitem>
 							<!--                                                                                                                                                    the second section                                                                                                                                                    -->
 							<para>
@@ -499,16 +538,16 @@
 											<menuchoice><guilabel>Help</guilabel></menuchoice> is the guide for questions about GNOME.
 										</para>
 									</listitem>
-									<listitem>
+								<!--	<listitem>
 										<para>
 											<menuchoice><guilabel>About GNOME</guilabel></menuchoice> tells you about GNOME and the people who made it.
 										</para>
-									</listitem>
-									<listitem>
+									</listitem>  -->
+								<!--	<listitem>
 										<para>
 											<menuchoice><guilabel>About Fedora</guilabel></menuchoice> is a guide containing documentation about the Fedora project.
 										</para>
-									</listitem>
+									</listitem> -->
 									<listitem>
 										<para>
 											<menuchoice><guilabel>About This Computer</guilabel></menuchoice> provides basic information about your computer and links to the process and resource monitor.
@@ -591,12 +630,12 @@
 					</imageobject>
 					<textobject>
 						<para>
-							The Tomboy icon
+							The Gnote icon
 						</para>
 					</textobject>
 					<caption>
 					<para>
-						The icon for <application>Tomboy</application>, note-taking software.
+						The icon for <application>Gnote</application>, note-taking software.
 					</para>
 					</caption>
 				</mediaobject>
@@ -606,9 +645,9 @@
 			</section>
 			
 			<section id="sect-User_Guide-_The_top_menu_panel_-_The_notification_area_">
-				<!--                                                                                                                                                    The notification area                                                                                                                                                    --><title> The notification area </title>
+				<!--                                                                                                                                                    The notification area                                                                                                                                                    --><title> The Notification area </title>
 				<para>
-					The notification area displays icons that alert you to new events taking place on your computer. For example, your email program might display an icon here to indicate the arrival of new email, or your printer software might display an icon here to indicate that a document is now printing.
+					The Notification area displays icons that alert you to new events taking place on your computer. For example, your email program might display an icon here to indicate the arrival of new email, or your printer software might display an icon here to indicate that a document is now printing.
 				</para>
 			</section>
 			
@@ -619,8 +658,14 @@
 				</para>
 			</section>
 			
-			<section id="sect-User_Guide-_The_top_menu_panel_-_The_user_switch_area_">
-				<!--                                                                                                                                                    The user switch area                                                                                                                                                    --><title> The user switch area </title>
+			<section id="sect-User_Guide-_The_top_menu_panel_-_The_Applet_Network_Manager_">
+<!--                                                                                                                                                    Applet Network Manager                                                                                                                                                    --><title> Applet Network Manager </title>
+				<para>
+					
+				</para>
+			</section>
+			
+			<section id="sect-User_Guide-_The_top_menu_panel_-_The_user_switch_area_">			<!--                                                                                                                                                    The user switch area                                                                                                                                                    --><title> The user switch area </title>
 				<para>
 					If you click the current username located next to the clock, a list of available users appears. To switch to a different user account, select the username.
 				</para>
@@ -680,13 +725,13 @@
 			<!--                                                                                                                                                    The window list panel                                                                                                                                                    --><title> The window list panel </title>
 			<!--                                                                                                                                                    [[Image:F10_bottom_panel2.png]]                                                                                                                                                    -->
 			<para>
-				This panel has four components: 
+				This panel has three components: 
 				<itemizedlist>
-					<listitem>
+				<!--	<listitem>
 						<para>
 							The <guilabel>Show Desktop</guilabel> button, on the left side, is used to hide all open windows, and reveal the desktop area. This function is useful when the open applications obscure an important desktop file or icon. To restore the windows, click the <guilabel>Show Desktop</guilabel> button again and all windows return to their previous location.
 						</para>
-					</listitem>
+					</listitem> -->
 					<listitem>
 						<para>
 							Any open applications appear as button icons in the middle part of the window list panel. It shows all application windows in use on the desktop workspace, whether they are visible or hidden. A hidden window button appears with a white background. The currently selected application window button has a gray background, and is said to have <firstterm>focus</firstterm>. Usually, this is the application whose window is on top of all the others on the screen. To switch from one running application to another using the mouse, click on the desired application&#39;s button in the panel.