From ae8ba335bec0b388e74704e992ebe6804505af91 Mon Sep 17 00:00:00 2001
From: Yuri Chornoivan <yurchor@ukr.net>
Date: Fri, 2 Aug 2013 13:59:46 +0300
Subject: [PATCH] Fix minor typos in docs and messages

---
 doc/xml/firewall-applet.xml        | 6 +++---
 doc/xml/firewalld.richlanguage.xml | 2 +-
 doc/xml/firewalld.zone.xml         | 2 +-
 src/firewall-offline-cmd           | 4 ++--
 4 files changed, 7 insertions(+), 7 deletions(-)

diff --git a/doc/xml/firewall-applet.xml b/doc/xml/firewall-applet.xml
index fd20228..9f89081 100644
--- a/doc/xml/firewall-applet.xml
+++ b/doc/xml/firewall-applet.xml
@@ -109,7 +109,7 @@
 		<para>Connection to firewalld established</para>
 	      </listitem>
 	      <listitem>
-		<para>Connecton to firewalld lost</para>
+		<para>Connection to firewalld lost</para>
 	      </listitem>
 	      <listitem>
 		<para>Firewall has been reloaded</para>
@@ -124,7 +124,7 @@
 		<para>Activation, deactivation or change of zones bound to interfaces</para>
 	      </listitem>
 	      <listitem>
-		<para>Activation, deactivation or change of zones bound to sources adresses</para>
+		<para>Activation, deactivation or change of zones bound to sources addresses</para>
 	      </listitem>
 	    </itemizedlist>
 
@@ -176,7 +176,7 @@
 
 	    <itemizedlist>
 	      <listitem>
-		<para>Connecton to firewalld lost</para>
+		<para>Connection to firewalld lost</para>
 	      </listitem>
 	      <listitem>
 		<para>Panic mode has been enabled or disabled</para>
diff --git a/doc/xml/firewalld.richlanguage.xml b/doc/xml/firewalld.richlanguage.xml
index e3c9e2a..0046976 100644
--- a/doc/xml/firewalld.richlanguage.xml
+++ b/doc/xml/firewalld.richlanguage.xml
@@ -57,7 +57,7 @@
     </para>
 
     <para>
-      This page describes the rich language used in the command line client and D-Bus interface. For information about the rich language representation used in the the zone configuration files, please have a look at <citerefentry><refentrytitle>firewalld.zone</refentrytitle><manvolnum>5</manvolnum></citerefentry>.
+      This page describes the rich language used in the command line client and D-Bus interface. For information about the rich language representation used in the zone configuration files, please have a look at <citerefentry><refentrytitle>firewalld.zone</refentrytitle><manvolnum>5</manvolnum></citerefentry>.
     </para>
 
     <para>
diff --git a/doc/xml/firewalld.zone.xml b/doc/xml/firewalld.zone.xml
index baa5388..b94898e 100644
--- a/doc/xml/firewalld.zone.xml
+++ b/doc/xml/firewalld.zone.xml
@@ -306,7 +306,7 @@
 	    <term>to-port="<replaceable>portid</replaceable><optional>-<replaceable>portid</replaceable></optional>"</term>
             <listitem>
 	      <para>
-		The estination port or port range to forward to. If omitted, the value of the port= attribute will be used altogether with the to-addr attribute.
+		The destination port or port range to forward to. If omitted, the value of the port= attribute will be used altogether with the to-addr attribute.
 	      </para>
 	    </listitem>
 	  </varlistentry>
diff --git a/src/firewall-offline-cmd b/src/firewall-offline-cmd
index bf213cb..cebb237 100755
--- a/src/firewall-offline-cmd
+++ b/src/firewall-offline-cmd
@@ -165,7 +165,7 @@ def _addStandardOptions(parser):
                       action="callback", dest="services", type="service",
                       default=[ ],
                       metavar=_("<service>"), callback=_append_unique,
-                      help=_("Enable a service in the default zone (example: ssh"))
+                      help=_("Enable a service in the default zone (example: ssh)"))
     parser.add_option("-p", "--port",
                       action="callback", dest="ports", type="port",
                       metavar=_("<port>[-<port>]:<protocol>"),
@@ -198,7 +198,7 @@ def _addStandardOptions(parser):
                       default=[ ],
                       callback=_append_unique,
                       metavar=_("<icmp type>"),
-                      help=_("Block this ICMP type in in the default zone. The default is to accept all ICMP types."))
+                      help=_("Block this ICMP type in the default zone. The default is to accept all ICMP types."))
 
 def _parse_args(parser, args, options=None):
     try:
-- 
1.8.1.5